{
    "$graph": [
        {
            "class": "Workflow",
            "id": "#main",
            "requirements": [
                {
                    "class": "ScatterFeatureRequirement"
                },
                {
                    "class": "MultipleInputFeatureRequirement"
                },
                {
                    "class": "SubworkflowFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "int",
                    "id": "#main/conditional_run"
                },
                {
                    "type": "File",
                    "id": "#main/contamination_sites_bed"
                },
                {
                    "type": "File",
                    "id": "#main/contamination_sites_mu"
                },
                {
                    "type": "File",
                    "id": "#main/contamination_sites_ud"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#main/dbsnp_idx"
                },
                {
                    "type": "File",
                    "id": "#main/dbsnp_vcf"
                },
                {
                    "type": "File",
                    "id": "#main/indexed_reference_fasta"
                },
                {
                    "type": "File",
                    "id": "#main/input_bam"
                },
                {
                    "type": "string",
                    "id": "#main/output_basename"
                },
                {
                    "type": "File",
                    "id": "#main/reference_dict"
                },
                {
                    "type": "File",
                    "id": "#main/wgs_calling_interval_list"
                },
                {
                    "type": "File",
                    "id": "#main/wgs_evaluation_interval_list"
                }
            ],
            "steps": [
                {
                    "hints": [
                        {
                            "class": "https://sevenbridges.comAWSInstanceType",
                            "value": "c5.9xlarge"
                        }
                    ],
                    "run": "#gatk_haplotypecaller.cwl",
                    "in": [
                        {
                            "source": "#main/verifybamid/contamination",
                            "id": "#main/gatk_haplotypecaller/contamination"
                        },
                        {
                            "source": "#main/input_bam",
                            "id": "#main/gatk_haplotypecaller/input_bam"
                        },
                        {
                            "source": "#main/picard_intervallisttools/output",
                            "id": "#main/gatk_haplotypecaller/interval_list"
                        },
                        {
                            "source": "#main/indexed_reference_fasta",
                            "id": "#main/gatk_haplotypecaller/reference"
                        }
                    ],
                    "scatter": [
                        "#main/gatk_haplotypecaller/interval_list"
                    ],
                    "out": [
                        "#main/gatk_haplotypecaller/output"
                    ],
                    "id": "#main/gatk_haplotypecaller"
                },
                {
                    "run": "#gatk_indexfeaturefile.cwl",
                    "in": [
                        {
                            "source": "#main/dbsnp_vcf",
                            "id": "#main/index_dbsnp/input_file"
                        },
                        {
                            "source": "#main/dbsnp_idx",
                            "id": "#main/index_dbsnp/input_index"
                        }
                    ],
                    "out": [
                        "#main/index_dbsnp/output"
                    ],
                    "id": "#main/index_dbsnp"
                },
                {
                    "run": "#picard_collectgvcfcallingmetrics.cwl",
                    "in": [
                        {
                            "source": "#main/index_dbsnp/output",
                            "id": "#main/picard_collectgvcfcallingmetrics/dbsnp_vcf"
                        },
                        {
                            "source": "#main/output_basename",
                            "id": "#main/picard_collectgvcfcallingmetrics/final_gvcf_base_name"
                        },
                        {
                            "source": "#main/picard_mergevcfs/output",
                            "id": "#main/picard_collectgvcfcallingmetrics/input_vcf"
                        },
                        {
                            "source": "#main/reference_dict",
                            "id": "#main/picard_collectgvcfcallingmetrics/reference_dict"
                        },
                        {
                            "source": "#main/wgs_evaluation_interval_list",
                            "id": "#main/picard_collectgvcfcallingmetrics/wgs_evaluation_interval_list"
                        }
                    ],
                    "out": [
                        "#main/picard_collectgvcfcallingmetrics/output"
                    ],
                    "id": "#main/picard_collectgvcfcallingmetrics"
                },
                {
                    "run": "#picard_intervallisttools.cwl",
                    "in": [
                        {
                            "source": "#main/wgs_calling_interval_list",
                            "id": "#main/picard_intervallisttools/interval_list"
                        }
                    ],
                    "out": [
                        "#main/picard_intervallisttools/output"
                    ],
                    "id": "#main/picard_intervallisttools"
                },
                {
                    "run": "#picard_mergevcfs.cwl",
                    "in": [
                        {
                            "source": "#main/gatk_haplotypecaller/output",
                            "id": "#main/picard_mergevcfs/input_vcf"
                        },
                        {
                            "source": "#main/output_basename",
                            "id": "#main/picard_mergevcfs/output_vcf_basename"
                        }
                    ],
                    "out": [
                        "#main/picard_mergevcfs/output"
                    ],
                    "id": "#main/picard_mergevcfs"
                },
                {
                    "run": "#verifybamid_contamination.cwl",
                    "in": [
                        {
                            "source": "#main/contamination_sites_bed",
                            "id": "#main/verifybamid/contamination_sites_bed"
                        },
                        {
                            "source": "#main/contamination_sites_mu",
                            "id": "#main/verifybamid/contamination_sites_mu"
                        },
                        {
                            "source": "#main/contamination_sites_ud",
                            "id": "#main/verifybamid/contamination_sites_ud"
                        },
                        {
                            "source": "#main/input_bam",
                            "id": "#main/verifybamid/input_bam"
                        },
                        {
                            "source": "#main/output_basename",
                            "id": "#main/verifybamid/output_basename"
                        },
                        {
                            "source": "#main/indexed_reference_fasta",
                            "id": "#main/verifybamid/ref_fasta"
                        }
                    ],
                    "out": [
                        "#main/verifybamid/output",
                        "#main/verifybamid/contamination"
                    ],
                    "id": "#main/verifybamid"
                }
            ],
            "hints": [
                {
                    "class": "https://sevenbridges.commaxNumberOfParallelInstances",
                    "value": 4
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#main/picard_mergevcfs/output",
                    "id": "#main/gvcf"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#main/picard_collectgvcfcallingmetrics/output",
                    "id": "#main/gvcf_calling_metrics"
                },
                {
                    "type": "File",
                    "outputSource": "#main/verifybamid/output",
                    "id": "#main/verifybamid_output"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "id": "#gatk_haplotypecaller.cwl",
            "doc": "This tool calls germline SNPs and indels via local re-assembly of haplotypes.\nThe following programs are run in this tool:\n  - GATK PrintReads\n  - GATK HaplotypeCaller",
            "requirements": [
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 10000
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "kfdrc/gatk:4.beta.1-3.5"
                }
            ],
            "baseCommand": [
                "/gatk-launch",
                "--javaOptions",
                "-Xms2000m"
            ],
            "arguments": [
                {
                    "position": 1,
                    "shellQuote": false,
                    "valueFrom": "PrintReads -I $(inputs.input_bam.path) --interval_padding 500 -L $(inputs.interval_list.path) -O local.sharded.bam && java -XX:GCTimeLimit=50 -XX:GCHeapFreeLimit=10 -Xms8000m -jar /GenomeAnalysisTK.jar -T HaplotypeCaller -R $(inputs.reference.path) -o $(inputs.input_bam.nameroot).vcf.gz -I local.sharded.bam -L $(inputs.interval_list.path) -ERC GVCF --max_alternate_alleles 3 -variant_index_parameter 128000 -variant_index_type LINEAR -contamination $(inputs.contamination) --read_filter OverclippedRead"
                }
            ],
            "inputs": [
                {
                    "type": "float",
                    "doc": "Fraction of contamination in sequencing data (for all samples) to aggressively remove",
                    "id": "#gatk_haplotypecaller.cwl/gatk_haplotypecaller/contamination"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        "^.bai"
                    ],
                    "doc": "Input bam file",
                    "id": "#gatk_haplotypecaller.cwl/gatk_haplotypecaller/input_bam"
                },
                {
                    "type": "File",
                    "doc": "File containing one or more genomic intervals over which to operate",
                    "id": "#gatk_haplotypecaller.cwl/gatk_haplotypecaller/interval_list"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        "^.dict",
                        ".fai"
                    ],
                    "doc": "Reference fasta with associated dict and fai indexes",
                    "id": "#gatk_haplotypecaller.cwl/gatk_haplotypecaller/reference"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "*.vcf.gz"
                    },
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#gatk_haplotypecaller.cwl/gatk_haplotypecaller/output"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "id": "#gatk_indexfeaturefile.cwl",
            "doc": "Creates an index for a feature file, e.g. VCF or BED file.",
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "kfdrc/gatk:4.1.7.0R"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        "$(inputs.input_file)",
                        "$(inputs.input_index)"
                    ]
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ResourceRequirement"
                },
                {
                    "class": "ShellCommandRequirement"
                }
            ],
            "baseCommand": [],
            "arguments": [
                {
                    "position": 0,
                    "shellQuote": false,
                    "valueFrom": "$(inputs.input_index ? 'echo /gatk' : '/gatk')"
                },
                {
                    "position": 1,
                    "shellQuote": false,
                    "valueFrom": "IndexFeatureFile "
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "doc": "Feature file (eg., VCF or BED file) to index. Must be in a tribble-supported format",
                    "inputBinding": {
                        "position": 2,
                        "prefix": "-I"
                    },
                    "id": "#gatk_indexfeaturefile.cwl/gatk_indexfeaturefile/input_file"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "doc": "Index file for the input_file, if one exists",
                    "id": "#gatk_indexfeaturefile.cwl/gatk_indexfeaturefile/input_index"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.input_file.basename)"
                    },
                    "secondaryFiles": [
                        ".idx"
                    ],
                    "id": "#gatk_indexfeaturefile.cwl/gatk_indexfeaturefile/output"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "id": "#picard_collectgvcfcallingmetrics.cwl",
            "doc": "This tool collects summary and per-sample metrics about variant calls in a VCF file.\nThe following programs are run in this tool:\n  - picard CollectVariantCallingMetrics",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 3000,
                    "coresMin": 16
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "kfdrc/picard:2.18.2-dev"
                }
            ],
            "baseCommand": [
                "java",
                "-Xms2000m",
                "-jar",
                "/picard.jar",
                "CollectVariantCallingMetrics"
            ],
            "arguments": [
                {
                    "position": 1,
                    "shellQuote": false,
                    "valueFrom": "INPUT=$(inputs.input_vcf.path) OUTPUT=$(inputs.final_gvcf_base_name) DBSNP=$(inputs.dbsnp_vcf.path) SEQUENCE_DICTIONARY=$(inputs.reference_dict.path) TARGET_INTERVALS=$(inputs.wgs_evaluation_interval_list.path) GVCF_INPUT=true THREAD_COUNT=16"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".idx"
                    ],
                    "doc": "dbsnp VCF file",
                    "id": "#picard_collectgvcfcallingmetrics.cwl/gatk_collectgvcfcallingmetrics/dbsnp_vcf"
                },
                {
                    "type": "string",
                    "doc": "String to use as the base filename for the output",
                    "id": "#picard_collectgvcfcallingmetrics.cwl/gatk_collectgvcfcallingmetrics/final_gvcf_base_name"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "doc": "Input VCF file",
                    "id": "#picard_collectgvcfcallingmetrics.cwl/gatk_collectgvcfcallingmetrics/input_vcf"
                },
                {
                    "type": "File",
                    "doc": "Reference dict index file",
                    "id": "#picard_collectgvcfcallingmetrics.cwl/gatk_collectgvcfcallingmetrics/reference_dict"
                },
                {
                    "type": "File",
                    "doc": "Target intervals to restrict analysis to",
                    "id": "#picard_collectgvcfcallingmetrics.cwl/gatk_collectgvcfcallingmetrics/wgs_evaluation_interval_list"
                }
            ],
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*_metrics"
                    },
                    "id": "#picard_collectgvcfcallingmetrics.cwl/gatk_collectgvcfcallingmetrics/output"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "id": "#picard_intervallisttools.cwl",
            "doc": "This tool scatters a single interval list into many interval list files.\nThe following programs are run in this tool:\n  - picard IntervalListTools",
            "requirements": [
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "kfdrc/picard:2.18.2-dev"
                }
            ],
            "baseCommand": [
                "java",
                "-Xmx2000m",
                "-jar",
                "/picard.jar"
            ],
            "arguments": [
                {
                    "position": 1,
                    "shellQuote": false,
                    "valueFrom": "IntervalListTools SCATTER_COUNT=50 SUBDIVISION_MODE=BALANCING_WITHOUT_INTERVAL_SUBDIVISION_WITH_OVERFLOW UNIQUE=true SORT=true BREAK_BANDS_AT_MULTIPLES_OF=1000000 INPUT=$(inputs.interval_list.path) OUTPUT=$(runtime.outdir)"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "doc": "Input interval list",
                    "id": "#picard_intervallisttools.cwl/picard_intervallisttools/interval_list"
                }
            ],
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "temp*/*.interval_list"
                    },
                    "id": "#picard_intervallisttools.cwl/picard_intervallisttools/output"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "id": "#picard_mergevcfs.cwl",
            "doc": "This tool merges many VCFs into a single VCF.\nThe following programs are run in this tool:\n  - picard MergeVcfs",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 3000
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "kfdrc/picard:2.18.2-dev"
                }
            ],
            "baseCommand": [
                "java",
                "-Xms2000m",
                "-jar",
                "/picard.jar",
                "MergeVcfs"
            ],
            "arguments": [
                {
                    "position": 1,
                    "shellQuote": false,
                    "valueFrom": "OUTPUT=$(inputs.output_vcf_basename).g.vcf.gz"
                }
            ],
            "inputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File",
                        "inputBinding": {
                            "prefix": "INPUT=",
                            "separate": false
                        }
                    },
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "doc": "List of input VCF files",
                    "id": "#picard_mergevcfs.cwl/picard_mergevcfs/input_vcf"
                },
                {
                    "type": "string",
                    "doc": "String to be used as the base filename for the output",
                    "id": "#picard_mergevcfs.cwl/picard_mergevcfs/output_vcf_basename"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "*.vcf.gz"
                    },
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#picard_mergevcfs.cwl/picard_mergevcfs/output"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "id": "#verifybamid_contamination.cwl",
            "doc": "This tool verifies whether the reads in particular file match previously known genotypes for an individual\nand checks whether the reads are contaminated as a mixture of two samples.\nThe following programs are run in this tool:\n  - VerifyBamID",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "kfdrc/verifybamid:1.0.2"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 5000,
                    "coresMin": 4
                }
            ],
            "baseCommand": [
                "/bin/VerifyBamID"
            ],
            "arguments": [
                {
                    "position": 1,
                    "shellQuote": false,
                    "valueFrom": "--Verbose --NumPC 4 --Output $(inputs.output_basename) --BamFile $(inputs.input_bam.path) --Reference $(inputs.ref_fasta.path) --UDPath $(inputs.contamination_sites_ud.path) --MeanPath $(inputs.contamination_sites_mu.path) --BedPath $(inputs.contamination_sites_bed.path) 1>/dev/null"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "doc": ".Bed file for markers used in this analysis,format(chr\tpos-1\tpos\trefAllele\taltAllele)",
                    "id": "#verifybamid_contamination.cwl/verifybamid_contamination/contamination_sites_bed"
                },
                {
                    "type": "File",
                    "doc": ".mu matrix file of genotype matrix",
                    "id": "#verifybamid_contamination.cwl/verifybamid_contamination/contamination_sites_mu"
                },
                {
                    "type": "File",
                    "doc": ".UD matrix file from SVD result of genotype matrix",
                    "id": "#verifybamid_contamination.cwl/verifybamid_contamination/contamination_sites_ud"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        "^.bai"
                    ],
                    "doc": "Input bam file",
                    "id": "#verifybamid_contamination.cwl/verifybamid_contamination/input_bam"
                },
                {
                    "type": "string",
                    "doc": "String to be used as the base filename for the output",
                    "id": "#verifybamid_contamination.cwl/verifybamid_contamination/output_basename"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".fai"
                    ],
                    "doc": "Reference fasta and fai index",
                    "id": "#verifybamid_contamination.cwl/verifybamid_contamination/ref_fasta"
                }
            ],
            "outputs": [
                {
                    "type": "float",
                    "outputBinding": {
                        "glob": "*.selfSM",
                        "loadContents": true,
                        "outputEval": "${\n  var lines = self[0].contents.split('\\n');\n  for (var i = 1; i < lines.length; i++) {\n    var fields = lines[i].split('\\t');\n    if (fields.length != 19) {\n      continue;\n    }\n    return fields[6]/0.75;\n  }\n}"
                    },
                    "id": "#verifybamid_contamination.cwl/verifybamid_contamination/contamination"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "*.selfSM"
                    },
                    "id": "#verifybamid_contamination.cwl/verifybamid_contamination/output"
                }
            ]
        }
    ],
    "cwlVersion": "v1.0",
    "$namespaces": {
        "sbg": "https://sevenbridges.com"
    }
}
